/******************************************************************************/
/*                                                                            */
/*                              I N C L U D E S                               */
/*                                                                            */
/******************************************************************************/
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>
#include <i86.h>
#include <string.h>
#include "vesalint.h"
#include "example.h"

void Set_Mode(unsigned int);
#pragma aux Set_Mode=\
"int    10h"\
modify  [ax]\
parm    [ax]

void set_80x50 (void);
#pragma aux set_80x50=\
"  mov ax, 1202h "\
"  mov bl, 30h   "\
"  int 10h       "\
"  mov ax, 3     "\
"  int 10h       "\
"  mov ax, 1112h "\
"  mov bl, 0     "\
"  int 10h       "\
modify [bx ax] parm [ax]

void set_blink(unsigned char onoff);
#pragma aux set_blink=\
"  mov ax,1003h  "\
"  int 10h       "\
modify [bx ax] parm [bl]

void Cursoroff(void);
#pragma aux Cursoroff =\
"mov ah,1     "\
"mov ch,1     "\
"mov cl,0     "\ 
"int 0x10     "\
modify [ax cx] 

char ch0='';
char ch1='';
char ch2='';
char ch3='';
char ch4='';

char chlist[5]={'','','','',''};
unsigned char colist[48]={
                             0,  0,  0,
                             0,  0,168,
                             0,168,  0,
                             0,168,168,
                           168,  0,  0,
                           168,  0,168,
                           168, 84,  0,
                           168,168,168,
                            84, 84, 84,
                            84, 84,252,
                            84,252, 84,
                            84,252,252,
                           252, 84, 84,
                           252, 84,252,
                           252,252, 85,
                           252,252,252  
                          };

unsigned char conv_table[65536];
float dist (UBYTE R1,UBYTE R2,UBYTE 

unsigned char *text_scr = (unsigned char *)0xB8000;

void Init_text(void)
{
    Set_Mode (0x3);
    set_80x50();
    set_blink(0);
    Cursoroff();
}

testgraf(void)
{
    int x,y;
    for (y=0;y<16;y++)
    for (x=0;x<16;x++)
    {
        WorkBuffer[(y*Active.Work.Width+x)*3  ]=colist[3*y+2];
        WorkBuffer[(y*Active.Work.Width+x)*3+1]=colist[3*y+1];
        WorkBuffer[(y*Active.Work.Width+x)*3+2]=colist[3*y  ];
    }
    Flip(WorkBuffer);
    getch();
}

void textest (void)
{
    int x,y,c;
    Set_Mode (0x3);
    set_80x50();
    set_blink(0);
    for (c=0;c<5;c++)
    for (y=0;y<16;y++)
    for (x=0;x<16;x++)
    {
        text_scr[y*160+x*2+c*32]=chlist[c];
        text_scr[y*160+x*2+c*32+1]=x+(y<<4);
    }
        
    getch();
    Set_Mode (0x3);
}

VOID    main(int argc, char *argv[])
{
                    textest();
                    Active.Screen.Width=320;
                    Active.Screen.Height=200;
                    Active.Screen.bpp=32;

                    Active.Work.Width=80;
                    Active.Work.Height=50;
                    Active.Work.bpp=24;

                    Active.EnableLFB=1;

                    if (!InitSetMode())
                    {
                        getch();
                        Active.Screen.bpp=24;
                        if (!InitSetMode())
                        {
                            getch();
                            Active.Screen.bpp=16;
                            if (!InitSetMode())
                            {
                                getch();
                                Active.Screen.bpp=15;
                                if (!InitSetMode())
                                {
                                    getch();
                                    Active.Screen.bpp=-1;
                                    Active.Screen.Height*=2;
                                    InitSetMode();
                                }
                            }
                        }
                    }
                        WorkBuffer=(UBYTE *) malloc(Active.Work.ResolSize);
                        if(WorkBuffer!=NULL) testgraf();
                        else
                        {
                                Error_Code=1;
                                ErrorMsg();
                        }
                
                if(!Free_Memory()) ErrorMsg();
                
                if(Active.Work.bpp==8)
                {
                        free(Active.Palette);
                }               
}

