extern  MODE Vesa_Modes[256];	//imported to use in this example

#define FLI_256_COLOR	4
#define FLI_DELTA	7
#define FLI_MINI	18	//exclusive of flc files
#define FLI_COLOR       11
#define FLI_LC          12
#define FLI_BACK        13
#define FLI_BRUN        15
#define FLI_COPY        16


typedef struct fli_header
{
        UDWORD  size;
        UWORD   magic;
        UWORD   frames;
        UWORD   width;
        UWORD   height;
        UWORD   depth;
        UWORD   flags;
        UDWORD  speed;
        UDWORD  next;
        UDWORD  frit;
        UBYTE   expand[100];
}FLI_HEADER;

typedef struct frame_header
{
	UDWORD	size;
	UWORD	magic;
	UWORD	chunks;
	UBYTE	expand[8];
}FRAME_HEADER;

typedef struct chunk
{
        UDWORD  size;
	UWORD   type;
}CHUNK;

//LOCAL FUNCTIONS
VOID    (interrupt far *BIOSTimerHandler)(void) = NULL;
VOID    interrupt far OurTimerHandler(void);
static BOOL    Read_Fli(char *name);
static VOID    Read_Chunk();
static VOID    Read_Header(FILE *In,FLI_HEADER *header);
static VOID    Show_Header(FLI_HEADER *header);
static VOID    Read_Frame_Header(FILE *In);
static VOID    ffli_brun(FLI_HEADER *header);
static VOID    ffli_lc();
static VOID    ffli_delta();
static VOID    ffli_color();
static VOID    ffli_256_color();
static VOID    ffli_black();
static VOID    ffli_copy(FLI_HEADER *header);
static VOID    InitTimerHandler(VOID);
static VOID    EndTimerHandler(VOID);
static VOID    OwnErrorMsg(UBYTE *aux);
static VOID    WaitKey();

//IN-LINE FUNCTIONS
VOID	Set_Mode(UWORD Mode);
VOID	Wait();
VOID	ClsD(UBYTE *Buff, UDWORD Bytes);

//LOCAL VARIABLES
static UDWORD		tics,milisec;
static UBYTE		*Buffer,*SBuffer;
static UDWORD		BufferPos;
static FRAME_HEADER	*frame_header;
static CHUNK		*chunk;
static BOOL		FromDisk;
static UBYTE		OwnError_Code;
static SDWORD		Gargc;
static UBYTE		*Gargv2;