#define TIMER_RATE  (1193180/1000)
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <string.h>
#include "vesalint.h"
#include "choice.h"
#include "example.h"

VOID	main(SDWORD argc, UBYTE *argv[])
{
	Gargc=argc;
	Gargv2=argv[2];
	printf(" FLI/FLC player by DP/SAVAGE. (Size of fli/flc unlimited!)\n");
	if(argc>1)
	{
		Read_Fli(argv[1]);		
	}
	else
	{
		printf("Use: playfl <nameoffli.fli> [-S] \n");
		printf("or     \n");
		printf("Use: playfl <nameofflc.flc> [-S] \n");

	}
}

static BOOL    Read_Fli(UBYTE *Name)
{
	FILE		*In;
	FLI_HEADER	fli_header;
	UWORD		n,frame=0;
	BOOL		select,Scale;
	UDWORD		Center;
	UWORD		opt;
	
	In=fopen(Name,"rb");
	if(In!=NULL)
	{
		Read_Header(In,&fli_header);
		if(fli_header.magic==0xaf11)
		{		
			milisec=fli_header.speed*1000/70;
			printf("FLI file.\n");
		}
		else if(fli_header.magic==0xaf12)
		{
			milisec=fli_header.speed;
			printf("FLC file.\n");
		}
		else
		{
			Set_Mode(0x3);
			printf("Invalid type file.\n");
			return(FALSE);
		}
		/* Show_Header(&fli_header); */

		if(milisec==0) milisec=1;

                Buffer=(UBYTE*) malloc(fli_header.size-sizeof(FLI_HEADER));
                if(Buffer!=NULL)
                {
			printf("Loading FLI/FLC.Please Wait...\n");
                        fread(Buffer,fli_header.size-sizeof(FLI_HEADER),1,In);
                        BufferPos=0;
                        FromDisk=FALSE;
                }
                else
                {
                        FromDisk=TRUE;
                }
		WaitKey();
		opt=0;
		do
		{
                        if(FromDisk) fseek(In,sizeof(FLI_HEADER),SEEK_SET);

			do
			{
                                select=Choice(5,4,75,23,&opt);
				if(select)
				{
                                        if(Vesa_Modes[opt].bpp<8)
					{
						Set_Mode(0x3);
                                                printf("The mode selected is under 8 bpp!!!.\n");
						getch();
					}
				}				
                        }while(Vesa_Modes[opt].bpp<8 && select);
	if(Gargc==2)
	{
		Scale=FALSE;
	}
	else if(strcmp(Gargv2,"-s")==0 || strcmp(Gargv2,"-S")==0 ||
	        strcmp(Gargv2,"/s")==0 || strcmp(Gargv2,"/S")==0)
	{
		Scale=TRUE;
	}
	else	Scale=FALSE;

	if(Scale)
	{
		Active.Screen.Width=Vesa_Modes[opt].Width;
		Active.Screen.Height=Vesa_Modes[opt].Height;
		Active.Screen.bpp=Vesa_Modes[opt].bpp;
	
		Active.Work.Width=320;
		Active.Work.Height=200;
		Active.Work.bpp=8;
	}
	else
	{
		Active.Work.Width=Vesa_Modes[opt].Width;
		Active.Work.Height=Vesa_Modes[opt].Height;

		Active.Screen.Width=Active.Work.Width;
		Active.Screen.Height=Active.Work.Height;

		Active.Screen.bpp=Vesa_Modes[opt].bpp;
		Active.Work.bpp=8;
	}

		Active.EnableLFB=1;

			Center=(Active.Work.Width-fli_header.width)/2+((Active.Work.Height-fli_header.height)/2)*Active.Work.Width;

			InitTimerHandler();
			if(Active.Screen.bpp!=8)
			{
				Active.Palette=(COLOR*) malloc(256*sizeof(COLOR));

				if(Active.Palette==NULL)
				{
					OwnError_Code=21;
					OwnErrorMsg(NULL);
					return(FALSE);
				}
			}

			if(select)
			{
				frame=0;
				BufferPos=0;

				Set_Mode(0x3);

				if(InitSetMode())
				{
 					SBuffer=(UBYTE *) malloc(Active.Work.ResolSize);
					if(SBuffer==NULL)
					{
						OwnError_Code=21;
						OwnErrorMsg(NULL);
						return(FALSE);
					}
					ClsD(SBuffer,Active.Work.ResolSize/4);
					SBuffer+=Center;

					while(!kbhit())
					{
                                                do
                                                {
                                                        Read_Frame_Header(In);                                                        
							if(FromDisk)
							{
	                                                        if(frame_header->magic!=0xf1fa) fseek(In,frame_header->size-sizeof(FRAME_HEADER),SEEK_CUR);
							}
							else
							{
                                                              	if(frame_header->magic!=0xf1fa) BufferPos=BufferPos+frame_header->size-sizeof(FRAME_HEADER);
							}
                                                }while(frame_header->magic!=0xf1fa);


						if(FromDisk)
						{
							Buffer=(UBYTE*) malloc(frame_header->size-sizeof(FRAME_HEADER));
							fread(Buffer,frame_header->size-sizeof(FRAME_HEADER),1,In);
							BufferPos=0;
						}

						for(n=1;n<=frame_header->chunks;++n)
						{
							Read_Chunk();
							if(chunk->size>sizeof(CHUNK))
							{
								switch(chunk->type)
								{
									case	FLI_DELTA:
										ffli_delta();
										break;

									case	FLI_COLOR:
										ffli_color();
										break;

                                                                        case    FLI_256_COLOR:
                                                                                ffli_256_color();
                                                                                break;

									case	FLI_LC:
										ffli_lc();
										break;
				
									case	FLI_BACK:
										ffli_black();
										break;
				
									case	FLI_BRUN:
										ffli_brun(&fli_header);
										break;
		
									case	FLI_COPY:
										ffli_copy(&fli_header);
										break;
									default:
										BufferPos=BufferPos+chunk->size-sizeof(CHUNK);
								}
							}
							if(BufferPos%2!=0) BufferPos++;
						}

						Flip(SBuffer-Center);
						++frame;	
						Wait();
						if(frame==fli_header.frames) //+1
						{
							frame=0;

							if(FromDisk)
							{
								fseek(In,sizeof(FLI_HEADER),SEEK_SET);
							}
							else
							{
								BufferPos=0;
							}
						}
						if(FromDisk) free(Buffer);
					}
					free(SBuffer-Center);
				}
				if(!Free_Memory()) ErrorMsg();
			}
			EndTimerHandler();
			if(Active.Screen.bpp!=8) free(Active.Palette);
		}while(select);
		if(!FromDisk) free(Buffer);
		Set_Mode(0x3);
		fclose(In);
	}
	else
	{
		OwnError_Code=22;
		OwnErrorMsg(Name);
		return(FALSE);
	}
	return(TRUE);
}

static VOID    Read_Chunk()
{
	UWORD	size=sizeof(CHUNK);
	UBYTE	*temp;

	temp=Buffer+BufferPos;
	
	chunk=(struct chunk*) temp;
	BufferPos+=size;
}

static VOID    Read_Header(FILE *In,FLI_HEADER *header)
{
	fread(header,sizeof(FLI_HEADER),1,In);
}
/*
static VOID    Show_Header(FLI_HEADER *header)
{
	printf("Size	: %u\n",header->size);
	printf("Magic	: %u\n",header->magic);
	printf("Frames	: %u\n",header->frames);
	printf("Width	: %u\n",header->width);
	printf("Height	: %u\n",header->height);
	printf("Depth	: %u\n",header->depth);
	printf("Flags	: %u\n",header->flags);
	printf("Speed	: %u\n",header->speed);
	printf("Next	: %u\n",header->next);
	printf("Frit	: %u\n",header->frit);
}
*/

static VOID    Read_Frame_Header(FILE *In)
{
	UWORD	size=sizeof(FRAME_HEADER);
	UBYTE	*temp;

        if(FromDisk)
        {
	        fread(frame_header,size,1,In);
	}
	else
	{
		temp=Buffer+BufferPos;
		frame_header=(FRAME_HEADER*) temp;//(struct frame_header*) temp;
	}
//	printf("frame_header magic:%u\n",frame_header->magic);
//	printf("frame_header size:%u\n",frame_header->size);
//	printf("frame_header chunks:%u\n",frame_header->chunks);
//	getch();
	BufferPos+=size;
}


/**********/
/*	  */
/**********/

static VOID    ffli_brun(FLI_HEADER *header)
{
	UBYTE	packets;	
	UWORD	n,y;
	SBYTE	size_count;
	UBYTE	data;
	UDWORD	pos=0;

	for(y=0;y<header->height;++y)
	{
		packets=Buffer[BufferPos];
		++BufferPos;

		for(n=0;n<packets;++n)
		{
			size_count=Buffer[BufferPos];
			++BufferPos;

			if(size_count<0)
			{
				for(size_count=-size_count;size_count>0;--size_count)
				{
					data=Buffer[BufferPos];
					++BufferPos;
					SBuffer[pos]=data;
					++pos;
				}
			}
			else
			{
				data=Buffer[BufferPos];
				++BufferPos;
				for(;size_count>0;--size_count)
				{
					SBuffer[pos]=data;
					++pos;
				}
			}
		}
		pos+=(Active.Work.Width-header->width);
	}
}

static VOID    ffli_lc()
{
	UBYTE	packets;	
	SWORD	n,n2,y,k;
	SBYTE	size_count;
	UBYTE	size_skip;
	UBYTE	data;
	UDWORD	pos;

	n=Buffer[BufferPos]+Buffer[BufferPos+1]*256;
	BufferPos+=2;

	n2=Buffer[BufferPos]+Buffer[BufferPos+1]*256;
	BufferPos+=2;

	y=n;
	while(n2>0)
	{
		packets=Buffer[BufferPos];
		++BufferPos;

		pos=y*Active.Work.Width;
		for(k=0;k<packets;++k)
		{
			size_skip=Buffer[BufferPos];
			++BufferPos;
			pos+=size_skip;
			size_count=Buffer[BufferPos];
			++BufferPos;
			if(size_count<0)
			{
				data=Buffer[BufferPos];
				++BufferPos;
				for(size_count=-size_count;size_count>0;--size_count)
				{
					SBuffer[pos]=data;
					++pos;
				}
			}	
			else
			{
				for(;size_count>0;--size_count)
				{
					data=Buffer[BufferPos];
					++BufferPos;
					SBuffer[pos]=data;
					++pos;
				}	
			}
		}
	n2--;
	++y;
	}
}

static VOID    ffli_delta()
{
	SWORD	packets;	
	SWORD	n2,y,k;
	SBYTE	size_count;
	UBYTE	size_skip;
	UBYTE	data1,data2;
	UDWORD	pos;

	n2=Buffer[BufferPos]+Buffer[BufferPos+1]*256;
	BufferPos+=2;
	y=0;
	while(n2>0)
	{
		packets=Buffer[BufferPos]+Buffer[BufferPos+1]*256;
		BufferPos+=2;
		if(packets<0) 	
		{
			y=y+(-packets);
		}
		else
		{
			pos=y*Active.Work.Width;
			for(k=0;k<packets;++k)
			{
				size_skip=Buffer[BufferPos];

				++BufferPos;
				pos+=size_skip;
				size_count=Buffer[BufferPos];

				++BufferPos;
				if(size_count<0)
				{
					data1=Buffer[BufferPos];
					data2=Buffer[BufferPos+1];
					BufferPos+=2;
					for(size_count=-size_count;size_count>0;--size_count)
					{
						SBuffer[pos]=data1;
						++pos;
						SBuffer[pos]=data2;
						++pos;
					}
				}	
				else
				{
					for(;size_count>0;--size_count)
					{
						data1=Buffer[BufferPos];
						data2=Buffer[BufferPos+1];
						BufferPos+=2;
						SBuffer[pos]=data1;
						++pos;
						SBuffer[pos]=data2;
						++pos;
					}	
				}
			}
			++y;
			n2--;
		}
	}
}


static VOID    ffli_color()
{
	UBYTE	i;
	UWORD	npackets;	
	UWORD	n;
	UWORD	currcol;

	npackets=Buffer[BufferPos]+Buffer[BufferPos+1]*256;
	BufferPos+=2;

	i=Buffer[BufferPos];
	++BufferPos;
	if(Active.Screen.bpp==8)
	{
		outp(0x3c8,i);
	}
	else
	{
		currcol=i;
	}
	n=Buffer[BufferPos];
	++BufferPos;

	if(n==0) n=256;
	for(;n>0;--n)
	{
		i=Buffer[BufferPos];
		++BufferPos;
		if(Active.Screen.bpp==8)
		{
			outp(0x3c9,i);
		}
		else
		{
			Active.Palette[currcol].r=i;
		}

		i=Buffer[BufferPos];
		++BufferPos;
		if(Active.Screen.bpp==8)
		{
			outp(0x3c9,i);
		}
		else
		{
			Active.Palette[currcol].g=i;
		}
		i=Buffer[BufferPos];
		++BufferPos;
		if(Active.Screen.bpp==8)
		{
			outp(0x3c9,i);
		}
		else
		{
			Active.Palette[currcol].b=i;
		}
		if(Active.Screen.bpp!=8)
		{
			++currcol;
		}
	}
	ReloadPalette();
}

static VOID    ffli_256_color()
{
	UBYTE	i;
	UWORD	npackets;	
	UWORD	currcol,n;

	npackets=Buffer[BufferPos]+Buffer[BufferPos+1]*256;
	BufferPos+=2;

	i=Buffer[BufferPos];
	++BufferPos;
	if(Active.Screen.bpp==8)
	{
		outp(0x3c8,i);
	}
	else
	{
		currcol=i;
	}
	n=Buffer[BufferPos];
	++BufferPos;

	if(n==0) n=256;
	for(;n>0;--n)
	{
		i=Buffer[BufferPos];
		++BufferPos;
		if(Active.Screen.bpp==8)
		{
			outp(0x3c9,i/4);
		}
		else
		{
			Active.Palette[currcol].r=i/4;
		}

		i=Buffer[BufferPos];
		++BufferPos;
		if(Active.Screen.bpp==8)
		{
			outp(0x3c9,i/4);
		}
		else
		{
			Active.Palette[currcol].g=i/4;
		}
		i=Buffer[BufferPos];
		++BufferPos;
		if(Active.Screen.bpp==8)
		{
			outp(0x3c9,i/4);
		}
		else
		{
			Active.Palette[currcol].b=i/4;
		}
		if(Active.Screen.bpp!=8)
		{
			++currcol;
		}
	}
	ReloadPalette();
}

static VOID    ffli_black()
{
	memset(SBuffer,0,Active.Work.ResolSize); //...
}

static VOID    ffli_copy(FLI_HEADER *header)
{
	UDWORD	x,y,pos;
	UBYTE	c;

	for(y=0;y<header->height;++y)
	{
		pos=y*Active.Work.Width;
		for(x=0;x<header->width;++x)
		{
			c=Buffer[BufferPos];
			SBuffer[pos]=c;
			++BufferPos;
			++pos;
		}
	}
}

VOID    interrupt far OurTimerHandler(void)
{
        ++tics;
        outp(0x20,0x20);
}

static VOID    InitTimerHandler(VOID)
{
    BIOSTimerHandler=_dos_getvect(0x08);
    _dos_setvect(0x08,OurTimerHandler);
    outp(0x43,0x34);
    outp(0x40,TIMER_RATE&0xff);
    outp(0x40,(TIMER_RATE>>8)&0xff);
}

static VOID    EndTimerHandler(VOID)
{
    _dos_setvect(0x08,BIOSTimerHandler);
    outp(0x43,0x34);	//0x36
    outp(0x40,0);
    outp(0x40,0);
}

static VOID    OwnErrorMsg(UBYTE *aux)
{
	Set_Mode(0x3);
	switch(OwnError_Code)
	{
		case 21:
			printf("Memory can not be allocated.\n");
			break;

		case 22:
			printf("%s not found.\n",aux);
			break;

	}
        WaitKey();
}

static VOID    WaitKey()
{
	while(kbhit()) getch();
	printf("Press any key to continue...\n");
	getch();
}

#pragma	aux Wait=\
"mov	[tics],0"\
"mov	eax,[milisec]"\
"@waitz:	"\
"cmp	[tics],eax"\
"jbe	@waitz"\
modify	[eax];

#pragma	aux ClsD=\
"XOR	EAX,EAX"\
"REP	STOSD"\
parm	[EDI] [ECX]\
modify	[eax ecx edi];

#pragma	aux Set_Mode=\
"int	10h"\
modify	[ax]\
parm	[ax]

